import { Construct } from "constructs";
import * as apig from "@aws-cdk/aws-apigatewayv2-alpha";
import { Api, ApiProps, ApiFunctionRouteProps } from "./Api";
import { Function as Fn, FunctionDefinition } from "./Function";
export interface ApolloApiProps extends Omit<ApiProps, "routes"> {
    readonly server: FunctionDefinition;
    readonly rootPath?: string;
}
export declare class ApolloApi extends Api {
    private lambdaIntegration?;
    private rootPath?;
    constructor(scope: Construct, id: string, props: ApolloApiProps);
    get serverFunction(): Fn;
    protected createFunctionIntegration(scope: Construct, routeKey: string, routeProps: ApiFunctionRouteProps, postfixName: string): apig.HttpRouteIntegration;
}
