import { SSTConstruct } from "./Construct";
declare type ExtractMetadata<T extends SSTConstruct> = ReturnType<T["getConstructMetadata"]> & {
    id: string;
    addr: string;
    stack: string;
};
import { Api } from "./Api";
export declare type ApiMetadata = ExtractMetadata<Api<any>>;
import { GraphQLApi } from "./GraphQLApi";
export declare type GraphQLApiMetadata = ExtractMetadata<GraphQLApi>;
import { ApiGatewayV1Api } from "./ApiGatewayV1Api";
export declare type ApiGatewayV1ApiMetadata = ExtractMetadata<ApiGatewayV1Api<any>>;
import { Auth } from "./Auth";
export declare type AuthMetadata = ExtractMetadata<Auth>;
import { AppSyncApi } from "./AppSyncApi";
export declare type AppSyncApiMetadata = ExtractMetadata<AppSyncApi>;
import { Bucket } from "./Bucket";
export declare type BucketMetadata = ExtractMetadata<Bucket>;
import { Cron } from "./Cron";
export declare type CronMetadata = ExtractMetadata<Cron>;
import { EventBus } from "./EventBus";
export declare type EventBusMetadata = ExtractMetadata<EventBus>;
import { Function as Fn } from "./Function";
export declare type FunctionMetadata = ExtractMetadata<Fn>;
import { KinesisStream } from "./KinesisStream";
export declare type KinesisStreamMetadata = ExtractMetadata<KinesisStream>;
import { NextjsSite } from "./NextjsSite";
export declare type NextjsMetadata = ExtractMetadata<NextjsSite>;
import { Queue } from "./Queue";
export declare type QueueMetadata = ExtractMetadata<Queue>;
import { StaticSite } from "./StaticSite";
export declare type StaticSiteMetadata = ExtractMetadata<StaticSite>;
import { Table } from "./Table";
export declare type TableMetadata = ExtractMetadata<Table>;
import { Topic } from "./Topic";
export declare type TopicMetadata = ExtractMetadata<Topic>;
import { WebSocketApi } from "./WebSocketApi";
export declare type WebSocketApiMetadata = ExtractMetadata<WebSocketApi>;
import { RDS } from "./RDS";
export declare type RDSMetadata = ExtractMetadata<RDS>;
export declare type Metadata = ApiMetadata | ApiGatewayV1ApiMetadata | AuthMetadata | AppSyncApiMetadata | BucketMetadata | CronMetadata | EventBusMetadata | FunctionMetadata | KinesisStreamMetadata | NextjsMetadata | QueueMetadata | StaticSiteMetadata | TableMetadata | TopicMetadata | WebSocketApiMetadata | GraphQLApiMetadata | RDSMetadata;
export {};
